searchData={"items":[{"type":"extras","title":"Raspberry Pi 5 Model B (64-bit)","doc":"# Raspberry Pi 5 Model B (64-bit)\n\n[![Hex version](https://img.shields.io/hexpm/v/nerves_system_rpi5.svg \"Hex version\")](https://hex.pm/packages/nerves_system_rpi5)\n[![CI](https://github.com/nerves-project/nerves_system_rpi5/actions/workflows/ci.yml/badge.svg)](https://github.com/nerves-project/nerves_system_rpi5/actions/workflows/ci.yml)\n[![REUSE status](https://api.reuse.software/badge/github.com/nerves-project/nerves_system_rpi5)](https://api.reuse.software/info/github.com/nerves-project/nerves_system_rpi5)\n\nThis is the base Nerves System configuration for the Raspberry Pi 5 Model B.\n\n![Raspberry Pi 5 image](assets/images/RaspberryPi_5B.svg)\n  [Efa / Wikimedia Commons / CC BY-SA\n4.0](https://en.wikipedia.org/wiki/Raspberry_Pi#/media/File:RaspberryPi_5B_28-08-2024.svg) \n\n| Feature              | Description                      |\n| -------------------- | -------------------------------- |\n| CPU                  | 2.4 GHz quad-core Cortex-A76     |\n| Memory               | 4 GB or 8 GB DRAM                |\n| Storage              | MicroSD                          |\n| Linux kernel         | 6.1 w/ Raspberry Pi patches      |\n| IEx terminal         | HDMI and USB keyboard (can be changed to UART) |\n| GPIO, I2C, SPI       | Yes - [Elixir Circuits](https://github.com/elixir-circuits) |\n| ADC                  | No                               |\n| PWM                  | Yes, but no Elixir support       |\n| UART                 | 2 available - `ttyAMA10`, `ttyAMA0` |\n| Display              | HDMI or 7\" RPi Touchscreen       |\n| Camera               | Official RPi Cameras (libcamera) |\n| Ethernet             | Yes                              |\n| WiFi                 | Yes - VintageNet                 |\n| Bluetooth            | Untested                         |\n| Audio                | HDMI/Stereo out                  |","ref":"readme.html"},{"type":"extras","title":"Using - Raspberry Pi 5 Model B (64-bit)","doc":"The most common way of using this Nerves System is create a project with `mix\nnerves.new` and to export `MIX_TARGET=rpi5`. See the [Getting started\nguide](https://hexdocs.pm/nerves/getting-started.html#creating-a-new-nerves-app)\nfor more information.\n\nIf you need custom modifications to this system for your device, clone this\nrepository and update as described in [Making custom\nsystems](https://hexdocs.pm/nerves/customizing-systems.html).","ref":"readme.html#using"},{"type":"extras","title":"Supported WiFi devices - Raspberry Pi 5 Model B (64-bit)","doc":"The base image includes drivers for the onboard Raspberry Pi 5 WiFi module\n(`brcmfmac` driver).","ref":"readme.html#supported-wifi-devices"},{"type":"extras","title":"Camera - Raspberry Pi 5 Model B (64-bit)","doc":"This system supports the official Raspberry Pi camera modules via\n[`libcamera`](https://libcamera.org/). The `libcamera` applications are included so it's\npossible to replicate many of the examples in the official [Raspberry Pi Camera\nDocumentation](https://www.raspberrypi.com/documentation/computers/camera_software.html).\n\nHere's an example commandline to run:\n\n```elixir\ncmd(\"libcamera-jpeg -n -v -o /data/test.jpeg\")\n```\n\nOn success, you'll get an image in `/data` that you can copy off with `sftp`.\n\nSince `libcamera` is being used instead of MMAL, the Elixir\n[picam](https://hex.pm/packages/picam) library won't work.","ref":"readme.html#camera"},{"type":"extras","title":"Audio - Raspberry Pi 5 Model B (64-bit)","doc":"The Raspberry Pi has many options for audio output. This system supports the\nHDMI and stereo audio jack output. The Linux ALSA drivers are used for audio\noutput.\n\nThe general Raspberry Pi audio documentation mostly applies to Nerves. For\nexample, to force audio out the HDMI port, run:\n\n```elixir\ncmd(\"amixer cset numid=3 2\")\n```\n\nChange the last argument to `amixer` to `1` to output to the stereo output jack.","ref":"readme.html#audio"},{"type":"extras","title":"RP1 PIO - Raspberry Pi 5 Model B (64-bit)","doc":"The `rpi1-pio` device driver allows use of the PIO hardware using\n[`piolib`](https://github.com/raspberrypi/utils/tree/master/piolib). If you\ndon't see `/dev/pio0`, the most likely cause is that you need to update your\nRaspberry Pi's boot EEPROM. See\n[rpi-eeprom](https://github.com/raspberrypi/rpi-eeprom) for binaries. It may be\neasier to upgrade the EEPROM via RaspberryPi OS if the instructions aren't\nclear.","ref":"readme.html#rp1-pio"},{"type":"extras","title":"Provisioning devices - Raspberry Pi 5 Model B (64-bit)","doc":"This system supports storing provisioning information in a small key-value store\noutside of any filesystem. Provisioning is an optional step and reasonable\ndefaults are provided if this is missing.\n\nProvisioning information can be queried using the Nerves.Runtime KV store's\n[`Nerves.Runtime.KV.get/1`](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.KV.html#get/1)\nfunction.\n\nKeys used by this system are:\n\nKey                    | Example Value     | Description\n:--------------------- | :---------------- | :----------\n`nerves_serial_number` | `\"12345678\"`      | By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi's device ID.\n\nThe normal procedure would be to set these keys once in manufacturing or before\ndeployment and then leave them alone.\n\nFor example, to provision a serial number on a running device, run the following\nand reboot:\n\n```elixir\niex> cmd(\"fw_setenv nerves_serial_number 12345678\")\n```\n\nThis system supports setting the serial number offline. To do this, set the\n`NERVES_SERIAL_NUMBER` environment variable when burning the firmware. If you're\nprogramming MicroSD cards using `fwup`, the commandline is:\n\n```sh\nsudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw\n```\n\nSerial numbers are stored on the MicroSD card so if the MicroSD card is\nreplaced, the serial number will need to be reprogrammed. The numbers are stored\nin a U-boot environment block. This is a special region that is separate from\nthe application partition so reformatting the application partition will not\nlose the serial number or any other data stored in this block.\n\nAdditional key value pairs can be provisioned by overriding the default\nprovisioning.conf file location by setting the environment variable\n`NERVES_PROVISIONING=/path/to/provisioning.conf`. The default provisioning.conf\nwill set the `nerves_serial_number`, if you override the location to this file,\nyou will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"Linux kernel and RPi firmware/userland - Raspberry Pi 5 Model B (64-bit)","doc":"There's a subtle coupling between the `nerves_system_br` version and the Linux\nkernel version used here. `nerves_system_br` provides the versions of\n`rpi-userland` and `rpi-firmware` that get installed. I prefer to match them to\nthe Linux kernel to avoid any issues. Unfortunately, none of these are tagged by\nthe Raspberry Pi Foundation so I either attempt to match what's in Raspbian or\ntake versions of the repositories that have similar commit times.","ref":"readme.html#linux-kernel-and-rpi-firmware-userland"},{"type":"extras","title":"Linux kernel configuration - Raspberry Pi 5 Model B (64-bit)","doc":"The Linux kernel compiled for Nerves is a stripped down version of the default\nRaspberry Pi Linux kernel. This is done to remove unnecessary features, select\nsome Nerves-specific features like F2FS and SquashFS support, and to save space.","ref":"readme.html#linux-kernel-configuration"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThis project does NOT follow semantic versioning. The version increases as\nfollows:\n\n1. Major version updates are breaking updates to the build infrastructure.\n   These should be very rare.\n2. Minor version updates are made for every major Buildroot release. This\n   may also include Erlang/OTP and Linux kernel updates. These are made four\n   times a year shortly after the Buildroot releases.\n3. Patch version updates are made for Buildroot minor releases, Erlang/OTP\n   releases, and Linux kernel updates. They're also made to fix bugs and add\n   features to the build infrastructure.","ref":"changelog.html"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"This is a major Buildroot update.\n\nPlease see the [nerves_system_br v1.30.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.30.0)\nfor upgrade instructions if you've forked this system.\n\n* Changes\n  * Enable support for the RP1's PIO feature\n  * Add REUSE compliance to help improve OSS copyright and licensing accuracy\n  * Update Raspberry Pi libraries and firmware to latest releases\n\n* Updated dependencies\n  * [Erlang/OTP 27.3](https://erlang.org/download/OTP-27.3.README.md)\n  * [Buildroot 2024.11.2](https://lore.kernel.org/buildroot/87v7t3nyls.fsf@dell.be.48ers.dk/T/)\n  * Linux 6.6.74 (Raspberry Pi 1.20250127 release)\n  * rpicam-apps 1.5.3\n  * rpi-libcamera v0.3.2+rpt20241119\n  * rpi-distro-firmware-nonfree 1:20230625-2+rpt3","ref":"changelog.html#v0-5-0"},{"type":"extras","title":"v0.4.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Changes\n  * Support the CM5 and any other devices that use the BCM2712D0\n  * Support the use of NVME SSDs\n  * Enable the RP1 PIO driver. This likely also requires the bootloader to be\n    updated to use\n\n* Updated dependencies\n  * [nerves_system_br v1.29.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.29.3)\n  * [Buildroot 2024.08.3](https://lore.kernel.org/buildroot/874j3e17ek.fsf@dell.be.48ers.dk/T/)\n  * [Erlang/OTP 27.2](https://erlang.org/download/OTP-27.2.README)\n  * Linux 6.6.64 with the Raspberry Pi and PREEMPT_RT patches\n  * [fwup v1.12.0](https://github.com/fwup-home/fwup/releases/tag/v1.12.0)","ref":"changelog.html#v0-4-1"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"This is a major Erlang and Buildroot update.\n\nPlease see the [nerves_system_br v1.29.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.29.0)\nfor upgrade instructions if you've forked this system.\n\n* Changes\n  * Applied and enabled the Real-Time Linux patch set, PREEMPT_RT. Please see\n    write-ups on the web for benefits and how to use. The impact of this patch\n    shouldn't be noticeable to most Nerves users.\n  * Switch CPU frequency governor from conservative to the more modern\n    schedutil. See [LWN article](https://lwn.net/Articles/682391/) for details.\n  * Add missing Pi Camera lens device driver\n\n* Updated dependencies\n  * [nerves_system_br v1.29.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.29.1)\n  * [Buildroot 2024.08.2](https://lore.kernel.org/buildroot/871pzex7gn.fsf@dell.be.48ers.dk/T/)\n  * Linux 6.6.51 (Raspberry Pi stable_20241008 release)","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Changes\n  * Enable QMI kernel modules to support many cellular modems without a Nerves\n    system update\n\n* Updated dependencies\n  * [nerves_system_br v1.28.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.3)\n  * [Buildroot 2024.05.2](https://lore.kernel.org/buildroot/87zfpfh147.fsf@dell.be.48ers.dk/T/)\n  * [Erlang/OTP 27.0.1](https://erlang.org/download/OTP-27.0.1.README)","ref":"changelog.html#v0-3-1"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"This is a major Erlang and Buildroot.\n\nPlease see the [nerves_system_br v1.28.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.0)\nfor upgrade instructions if you've forked this system.\n\n* Changes\n  * Elixir 1.17 and Erlang/OTP 27 support\n  * Reduce copy/pasted definitions in the `fwup.conf` by extracting them to\n    `fwup_include/fwup-common.conf`. (No functional changes)\n\n* Fixes\n  * The serial numbers returned by `Nerves.Runtime.serial_number/0` now contain\n    the whole serial number. If you forked this system, check the\n    `boardid.config` and `erlinit.config` for the changes and to keep the\n    hostname the same.\n\n* Updated dependencies\n  * [nerves_system_br v1.28.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.1)\n  * [Buildroot 2024.05](https://lore.kernel.org/buildroot/87bk46tjk2.fsf@dell.be.48ers.dk/T/)\n  * [Erlang/OTP 27.0](https://erlang.org/download/OTP-27.0.README)","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Changes\n  * Enable the `wpa_supplicant` option for allow wired 802.1x authentication\n\n* Package updates\n  * [Erlang/OTP 26.2.5](https://erlang.org/download/OTP-26.2.5.README)\n  * [Buildroot 2024.02.1](https://lore.kernel.org/buildroot/87jzlp9u5e.fsf@48ers.dk/T/)","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"This is a major Buildroot update.\n\nPlease see the [nerves_system_br v1.27.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.0)\nfor upgrade instructions if you've forked this system.\n\n* Changes\n  * Important documentation update to replace ttyS0 with ttyAMA10 for getting\n    the IEx prompt on the debug UART\n  * The `libcamera` and `rpicam_apps` packages have been replaced with the\n    Raspberry Pi-forked versions for better compatibility. Please see\n    `nerves_system_br` release notes.\n\n* Updated dependencies\n  * Linux 6.1.73 (Raspberry Pi 20240124 release)\n  * [nerves_system_br v1.27.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.27.0)\n  * [Buildroot 2024.02](https://lore.kernel.org/buildroot/87msrczp4z.fsf@48ers.dk/)\n  * [Erlang/OTP 26.2.3](https://erlang.org/download/OTP-26.2.3.README)","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"This is a major Buildroot update.\n\nPlease see the [nerves_system_br v1.26.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.0)\nfor upgrade instructions if you've forked this system.\n\n* New features\n  * Add the imx296 overlays for the Raspberry Pi Global Shutter Camera\n\n* Updated dependencies\n  * [Erlang/OTP 26.2.2](https://erlang.org/download/OTP-26.2.2.README)\n  * [nerves_system_br v1.26.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.1)\n  * [Buildroot 2023.11.1](https://lore.kernel.org/buildroot/87cyu2k2gu.fsf@48ers.dk/T/)","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"v0.0.2 - Changelog","doc":"This is a security/bug fix update.\n\n Package updates\n  * [Erlang/OTP 26.2.1](https://erlang.org/download/OTP-26.2.1.README)\n  * [nerves_heart 2.3.0](https://github.com/nerves-project/nerves_heart/releases/tag/v2.3.0)","ref":"changelog.html#v0-0-2"},{"type":"extras","title":"v0.0.1 - Changelog","doc":"This is an initial release to make it easier for more people to test Nerves on\nthe Raspberry Pi 5. Future releases may be incompatible and this one might have\nsome frustrating bugs.","ref":"changelog.html#v0-0-1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}